#include <stdio.h>
#include <string>
#include <map>
#include <vector>
#include <assert.h>
#include <algorithm>
using namespace std;

int p;
int w;
int q;

long double przel[6][6];
map<string, int> unit_index;
int n_units;
int primitive;

struct Wzorzec
{
    int value;
    string unit;
    long long abs_value;
    bool operator < (const Wzorzec& r) const
    {
        return abs_value < r.abs_value;
    }
};

vector<Wzorzec> wzorzec;

void init_przel()
{
    for (int i = 0; i < 6; i++) {
        for (int j = 0; j < 6; j++) {
            przel[i][j] = -1.0;
        }
        przel[i][i] = 1.0;
    }
}

void prepare_przel()
{
    int n_changed = 1;
    while (n_changed != 0) {
        n_changed = 0;
        for (int k = 0; k < n_units; k++) {
            for (int i = 0; i < n_units; i++) {
                for (int j = 0; j < n_units; j++) {
                    if (przel[i][j] < 0.0) {
                        if (przel[i][k] >= 0 && przel[k][j] >= 0) {
                            przel[i][j] = przel[i][k] * przel[k][j];
                            przel[j][i] = 1.0 / przel[i][j];
                            n_changed++;
                        }
                        /*if (przel[k][i] > 0 && przel[k][j] > 0) {
                            if (przel[k][j] >= przel[k][i]) {
                                przel[i][j] = przel[k][j] / przel[k][i];                                
                                przel[j][i] = 1.0 / przel[i][j];
                                n_changed++;
                            }
                        }
                        if (przel[i][k] > 0 && przel[j][k] > 0) {
                            if (przel[j][k] <= przel[i][k]) {
                                przel[i][j] = przel[i][k] / przel[j][k];                                
                                przel[j][i] = 1.0 / przel[i][j];
                                n_changed++;
                            }
                        }*/
                        //assert(przel[i][j]
                    }
                }
            }
        }
    }
    
    /*for (int i = 0; i < n_units; i++) {
       for (int j = 0; j < n_units; j++) {
           printf("%llf ", przel[i][j]);
       }
       printf("\n");
    }*/
}

int find_primitive_unit()
{
    for (int i = 0; i < n_units; i++) {
        int count = 0;
        for (int j = 0; j < n_units; j++) {
            if (przel[i][j] > 1) {
                count++;
            }
        }
        if (count == 0) {
            return i;
        }
    }
    for (;;);
    assert(0);
}

long double absolute(int x, string u)
{
    int iu = unit_index[u];
    //assert(x > 0);
    //printf("iu = %d, przel[iu][primitive] = %lld, primitive = %d\n", iu, przel[iu][primitive], primitive);
    //assert(przel[iu][primitive] > 0);
    return x * przel[iu][primitive];
}

int dist(Wzorzec w1, int abs_value)
{
    return abs(w1.abs_value - abs_value);
}

void print_wzorce()
{
    vector<Wzorzec>::iterator it;
    for (it = wzorzec.begin() ; it != wzorzec.end(); it++) {
        printf("%lld ", (*it).abs_value);
    }
    printf("\n");
}

int main()
{
    int d;
    scanf("%d", &d);
    while (d--) {
        scanf("%d", &p);
        n_units = 0;
        unit_index.clear();
        
        // przeliczniki
        init_przel();
        for (int i = 0; i < p; i++) {
            int k;
            char a[32], b[32], eq[32];
            int one;
            int ia, ib;
            scanf("%d %s %s %d %s", &one, a, eq, &k, b);
            assert(one == 1);
            assert(eq[0] == '=' && eq[1] == 0);
            if (unit_index.find(a) == unit_index.end()) {
                ia = n_units;
                unit_index[a] = n_units++;
            }
            else {
                ia = unit_index[a];
            }
            if (unit_index.find(b) == unit_index.end()) {
                ib = n_units;
                unit_index[b] = n_units++;
            }
            else {
                ib = unit_index[b];
            }
            przel[ia][ib] = k;
            przel[ib][ia] = 1.0 / k;
            assert(przel[ia][ib] > 0);
        }
        prepare_przel();
        primitive = find_primitive_unit();
        
        // wzorce
        scanf("%d", &w);
        wzorzec.clear();
        for (int i = 0; i < w; i++) {
            int x;
            char u[32];
            scanf("%d %s", &x, u);
            Wzorzec www;
            www.value = x;
            www.abs_value = absolute(x, u);
            www.unit = u;
            wzorzec.push_back(www);
        }
        sort(wzorzec.begin(), wzorzec.end());
        
        // zapytania
        //print_wzorce();
        scanf("%d", &q);
        for (int i = 0; i < q; i++) {
            int x;
            char u[32];
            scanf("%d %s", &x, u);
            Wzorzec www;
            www.abs_value = absolute(x, u);
            //printf("abs = %lld\n", www.abs_value);
            vector<Wzorzec>::iterator it1, it2;
            it1 = lower_bound(wzorzec.begin(), wzorzec.end(), www);
            if (it1 == wzorzec.end()) {
               printf("%d %s\n", wzorzec.back().value, wzorzec.back().unit.c_str());
            }
            else  if (it1 != wzorzec.begin()) {
                it2 = it1;
                --it2;
                if (dist(*it2, www.abs_value) <= dist(*it1, www.abs_value)) {
                    printf("%d %s\n", (*it2).value, (*it2).unit.c_str());
                }
                else {
                    printf("%d %s\n", (*it1).value, (*it1).unit.c_str());
                }
            }
            else {
                printf("%d %s\n", (*it1).value, (*it1).unit.c_str());
            }
        }
    }
    return 0;
}
