#include <cstdio>
#include <string>
#include <map>
#include <cassert>
using namespace std;

const int MAXUNIT = 10;

typedef map<string,int> UnitMap;

UnitMap units;
int graph[MAXUNIT][MAXUNIT];

int getName(char* name)
{
    UnitMap::iterator iter;
    iter = units.find(name);
    if(iter == units.end())
    {
        int i = (int)units.size();
        units.insert(make_pair(string(name),i));
        return i;
    }
    else
        return iter->second;
}

const string& getName(int n)
{
    UnitMap::iterator iter;
    for(iter = units.begin(); iter != units.end(); ++iter)
        if(iter->second == n)
            return iter->first;
            
    assert(0);
    return string();
}

int best_val;
int best_un;

bool solve(int un, int val)
{
    for(int i=units.size()-1; i>=0; --i)
    {
        if(i == un)
            continue;
        
        if(graph[un][i] != 0)
        {
            int d_un = i;
            int d_val = val*graph[un][i];
            solve(d_un,d_val);
            printf("%d %d\n", d_un, d_val);
        }
    }
    if(val > best_val)
    {
        best_val = val;
        best_un = un;
    }
}

int main()
{
    int sets;
    scanf("%d", &sets);
    for(int d=1; d<=sets; ++d)
    {
        char name1[20];
        char name2[20];
        char eq[10];
        
        units.clear();
        
        for(int i=0; i<MAXUNIT; ++i)
        {
            for(int j=0; j<MAXUNIT; ++j)
                graph[i][j] = 0;
            graph[i][i] = 1;
        }
        
        int p;
        scanf("%d", &p);
        for(int i=0; i<p; ++i)
        {
            int tmp1, val;
            scanf("%d %s %s %d %s", &tmp1, name1, eq, &val, name2);
            int u1,u2;
            u1 = getName(name1);
            u2 = getName(name2);
            
            graph[u1][u2] = val;                        
        }
       
/*
UnitMap::iterator iter;
for(iter = units.begin(); iter != units.end(); ++iter)
    printf("%s %d\n", iter->first.c_str(), iter->second);
*/
        
        int w;
        scanf("%d", &w);
        for(int i=0; i<w; ++i)
        {
            int un, val;
            scanf("%d %s", &val, name1);
            un = getName(name1);
            
            best_val = -1;
            solve(un, val);
            printf("%d %s\n", best_val, getName(best_un).c_str());
        }
    }

    return 0;
}
