#include <cstdio>
#include <list>
using namespace std;

int bases, ways;




struct Way
{
    int from;
    int to;
    int time;
    int cycle;
    int start;
    int length;
};

const int INFINITY = 1000000000;

typedef std::list<Way> WayList;
struct Base
{
    WayList ways;
    int dist;
};
const int MAXBASE = 50005;
Base base[MAXBASE];

class Heap
{
    public: 
        Heap() { n = 0; 
            for(int i=0; i<60000; ++i)
                whereis[i] = 0;
            } 
        
        void push(int a)
        {
            elem[++n] = a;
            whereis[a] = n;
            moveUp(n);
        }
        
        void pop()
        {
            whereis[elem[1]] = 0;
            whereis[elem[n]] = 1;
            elem[1] = elem[n--];
            moveDown(1);
        }
        
        int top() { return elem[1]; }
        bool empty() { return n == 0; }
        int size() { return n; }
        void clear() { n = 0; }
        
        void erase(int a)
        {
            int curr = whereis[a];
            if (curr == 0) return;
            int prev = curr >> 1;
            elem[0] = a;
            whereis[ elem[curr] ] = 0;
            whereis[ elem[n] ] = curr;
            elem[curr] = elem[n--];
            if (base[elem[curr]].dist < base[elem[prev]].dist) 
                moveUp(curr);
            else 
                moveDown(curr);
        }
    private:
        int elem[65536];
        int n;
        int whereis[65536];        
        
        void moveUp(int curr)
        {
            int v = elem[curr];
            int prev;
            elem[0] = v;
            while (base[v].dist < base[elem[prev = curr >> 1]].dist) {
                elem[curr] = elem[prev];
                whereis[elem[prev]] = curr;
                curr = prev;
            }
            elem[curr] = v;
            whereis[v] = curr;
        }
        
        void moveDown(int curr)
        {
            int v = elem[curr];
            int next;
            while ((next = curr << 1) <= n) {
                if (next < n && base[elem[next + 1]].dist < base[elem[next]].dist) next++;
                if (base[elem[next]].dist >= base[v].dist) break;
                elem[curr] = elem[next];
                whereis[elem[next]] = curr;
                curr = next;
            }
            elem[curr] = v;
            whereis[v] = curr;
        }
};

int dijkstra(void)
{
    Heap heap;
    heap.push(1);
    base[1].dist = 0;
    while (heap.empty() == false) {
        int a = heap.top();
//        printf("Zwiedzam %d\n", a);
        if (a == bases) {
            return base[a].dist;
        }
        heap.pop();
        WayList::iterator it;
        for (it = base[a].ways.begin(); it != base[a].ways.end(); ++it) {
            int b = (*it).to;
            //printf("sprawdzam %d\n", b);
            int d;
            if ((*it).cycle == 0 && (*it).start == 0 && (*it).length == 0) {
              //  printf("wolne\n");
                d = base[a].dist + (*it).time;
            }
            else if ((*it).time > (*it).length) {
                //printf("brak przejscia\n");
                d = INFINITY;
            }
            else {
                int t = base[a].dist;
                int i = t / (*it).cycle;
                do {
                    bool ok_start = ( t >= i * (*it).cycle + (*it).start);
                    bool ok_end   = ( t + (*it).time <= i * (*it).cycle + (*it).length + (*it).start);
                    if (ok_start && ok_end)
                    {
                //printf("mozna isc\n");
                        d = base[a].dist + (*it).time ;
                        break;
                    }
                    i++;
                }  while (1);
            }
            //printf("d = %d, dist = %d\n", d, base[b].dist);
            
            if (d < base[b].dist) {
            
                base[b].dist = d;
                heap.erase(b);
                heap.push(b);
            }
            
        }
    }
    return INFINITY;
}

int main()
{
    int sets;
    scanf("%d", &sets);
    for(int s=1; s<=sets; ++s)
    {
        scanf("%d %d", &bases, &ways);

        // init
        for(int i=1; i<=bases; ++i) {
            base[i].ways.clear();
            base[i].dist = INFINITY;
        }
        
        for(int i=0; i<ways; ++i)
        {
            Way tmp;
            scanf("%d %d %d %d %d %d",
                &tmp.from,
                &tmp.to,
                &tmp.time,
                &tmp.cycle,
                &tmp.start,
                &tmp.length);
            
            base[tmp.from].ways.push_back(tmp);
        }
        
/* DEBUG PRINT */
/*
for(int i=1; i<=bases; ++i)
{
    printf("BASE %d\n", i);
    printf("WAYS:\n");
    WayList::const_iterator it;
    for(it = base[i].ways.begin(); it != base[i].ways.end(); ++it)
        printf("  TO: %d\n", it->to);
}
*/    
        int res = dijkstra();
        if(res == INFINITY)
            printf("NIE\n");
        else
            printf("%d\n", res);
    
    
    
    }

    return 0;
}
