#include <cstdio>
using namespace std;

const int MAXN = 1050;
const int MAXVAL = 40010;

const int plA = 0;
const int plB = 1;

typedef char Result;
const Result UNKNOWN = -1;
const Result WIN = 1;
const Result LOSE = 2;

int table[MAXN];
int n;
int sum;
int half;
Result solve[MAXN][MAXVAL/2][2];

Result trysolve(int k, int player, int sumA, int sumB)
{
//printf("PLAYER: %d - %d - %d %d\n", player, k, sumA, sumB);

    if(solve[k][player == plA ? sumA : sumB][player] != UNKNOWN)
        return solve[k][player == plA ? sumA : sumB][player];

    if(player == plA)
    {
        int tmpsum = sumA;
        for(int i=0; i<4; ++i)
        {
            if(k+i+1 >= n)
                break;
            
            // bierze nastepna liczba
            tmpsum += table[k+i];
            
            // wygrywa
            if(tmpsum*2 == sum)
            {
                return solve[k][sumA][plA] = WIN;
            }
            // przegrywa
            else if(tmpsum*2 > sum)
            {
                return solve[k][sumA][plA] = LOSE;
            }
            // kontynuuje przeciwnik
            if(trysolve(k+i+1, plB, tmpsum, sumB) == LOSE)
            {
                // wygrana
                return solve[k][sumA][plA] = WIN;
            }
        }
        return solve[k][sumA][plA] = LOSE;
    }
    else // (player == plB)
    {
        int tmpsum = sumB;
        for(int i=0; i<4; ++i)
        {
            if(k+i+1 >= n)
                break;
            
            // bierze nastepna liczba
            tmpsum += table[k+i];
            
            // wygrywa
            if(tmpsum*2 == sum)
            {
                return solve[k][sumB][plB] = WIN;
            }
            // przegrywa
            else if(tmpsum*2 > sum)
            {
                return solve[k][sumB][plB] = LOSE;
            }
            // kontynuuje przeciwnik
            if(trysolve(k+i+1, plA, sumA, tmpsum) == LOSE)
            {
                // wygrana
                return solve[k][sumB][plB] = WIN;
            }
        }
        return solve[k][sumB][plB] = LOSE;
    }
}

int main()
{
    int sets;
    
    scanf("%d", &sets);
    
    while(sets-- > 0)
    {
        scanf("%d", &n);
        for(int i=0; i<n; ++i)
            scanf("%d", &table[i]);
            
        // elements sum
        sum = 0;
        for(int i=0; i<n; ++i)
            sum += table[i];
    
        // table initilization
        for(int i=0; i<=n; ++i)
            for(int j=0; j<=sum; ++j)
                solve[i][j][0] = solve[i][j][1] = UNKNOWN;
            
        // number = 0, player = 0, sumA = 0, sumB = 0
        if(trysolve(0, 0, 0, 0) == WIN)
            printf("TAK\n");
        else
            printf("NIE\n");
    }

    return 0;
}
